// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	// Borro contenido de los bloques y cargo datos
	limpiar_bloques();
	// Compruebo si se ha puesto dni/pass, si no muestro las preferencias
	if((widget.preferenceForKey('dni')==null || widget.preferenceForKey('dni')=='') || (widget.preferenceForKey('pass')==null || widget.preferenceForKey('pass')=='')){
		showBack();
	}else{
		$('#nombre').html('<img src="Images/loading_front.gif" style="vertical-align:-35%;margin-right:5px;" /> Cargando datos ...');
		login_umh();
	}
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	$('#dni').val(widget.preferenceForKey('dni'));
	$('#pass').val(widget.preferenceForKey('pass'));
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function login_umh(event)
{
// jQuery ajax para hacer login y cargar acceso.
// Recojo la cookie y la paso a la url del acceso ident
		var xhr = $.ajax({
			type: "POST",
			url: "http://umh.es/identificado/logon.asp",
			data: "dni="+widget.preferenceForKey('dni')+"&pin="+widget.preferenceForKey('pass'),
			success: function(msg){
			cargar_anuncios(xhr.getResponseHeader("Set-Cookie"), "http://umh.es/identificado/est/docencia.asp");
			},
			error:	function(msg){
				$('#nombre').html('Ocurrió un error al cargar los datos');
			}
		});
}

function cargar_anuncios(cookieumh, feedURL){
// Uso xmlhttprequest manualmente, ya que la función jQuery no permite setRequestHeader
var onloadHandler = function() { xmlLoaded(xmlRequest); };

// XMLHttpRequest setup code
var xmlRequest = new XMLHttpRequest();
xmlRequest.onload = onloadHandler;
xmlRequest.open("GET", feedURL);
xmlRequest.setRequestHeader("Cache-Control", "no-cache");
xmlRequest.setRequestHeader("Cookie", cookieumh);
xmlRequest.send(null);
}

function xmlLoaded(xmlRequest) 
{
	if (xmlRequest.status == 200) {
		parsear_resultado(xmlRequest.responseText);
	}
	else {
		//alert("Error fetching data: HTTP status " + xmlRequest.status);
		$('#nombre').html('Ocurrió un error al cargar los datos');
	}
}

function parsear_resultado(resultado){
	// BUG #1 CORREGIDO: Limpio bloques otra vez, si cargo otra vez
	// widget rapidamente antes de que haya terminado de cargar, el 
	// contenido se añade
	limpiar_bloques();
	
	// Obtengo y muestro el nombre del alumno
	var nombrealu = $(resultado).find('#Layer3 h5').text();
	$('#nombre').text(nombrealu);
	
	// Hago visible caja de contenido
	$('#box').show();
	// Obtengo y muestro número anuncios umh
	var numanunciosumh = $(resultado).find("a[title^='Ver anuncios de la UMH'] b");

	if(numanunciosumh.length){
		$('#anunciosumhtext').html('Anuncios de la UMH - <b>'+numanunciosumh.text()+'</b>');
	}else{
		$('#anunciosumhtext').html('Anuncios de la UMH - 0 no leídos');
	}
	// Obtengo y muestro listado anuncios umh no leídos
	var listadoumh = $(resultado).find('b a.tablon');
	if(listadoumh.length){
		
		//$('#scrollAreaumh #content').append(listadoumh);
		//$('#scrollAreaumh #content a').wrapAll('<ul></ul>');
		//$('#scrollAreaumh #content a').wrap('<li></li>');
		
		listadoumh.each(function(){
			var anuncio = $(this);
			$('#scrollAreaumh #content').append('<li>'+anuncio.text()+'</li>');
			
		});
		$('#scrollAreaumh #content li').wrapAll('<ul></ul>');
		document.getElementById("scrollAreaumh").object.refresh();
		
	}
	
	// Obtengo y muestro número anuncios titulacion
	var numanunciostit = $(resultado).find("a[title^='Ver anuncios de la titula'] b");

	if(numanunciostit.length){
		$('#anunciostitutext').html('Anuncios de titulación - <b>'+numanunciostit.text()+'</b>');
	}else{
		$('#anunciostitutext').html('Anuncios de titulación - 0 no leídos');
	}
	
	// Busco si hay anuncios en las asignaturas y los muestro
	var anunciosasig = $(resultado).find('a.asig').next().next().children('b');
	if(anunciosasig.length){
		anunciosasig.each(function(){
			var asignat = $(this).parent().prev().prev().text()+' - <b>'+$(this).text()+'</b>';
			$('#scrollAreaasig #contentasig').append('<li>'+asignat+'</li>');
		});
		$('#scrollAreaasig #contentasig li').wrapAll('<ul></ul>');
		document.getElementById("scrollAreaasig").object.refresh();
	}

}

// Guardamos dni/pass y giramos a front
function guardar_pref(event){

// Comprobamos que hayamos rellenado ambos campos
if($('#dni').val()=='' || $('#pass').val()==''){
	$('#errorpass').html('DNI o Contraseña incorrectos');
	return false;
}

// Comprobamos si la contraseña es correcta antes de guardarla
$('#errorpass').html('<img src="Images/loading_back.gif" style="vertical-align:-35%;margin-right:5px;" />');
	var xhr = $.ajax({
			type: "POST",
			url: "http://umh.es/identificado/logon.asp",
			data: "dni="+$('#dni').val()+"&pin="+$('#pass').val(),
			dataType: "text",
			success: function(msg){
				if(msg.search(/RESTRINGIDO/)==-1){
					widget.setPreferenceForKey($('#dni').val(), 'dni');
					widget.setPreferenceForKey($('#pass').val(), 'pass');
					$('#errorpass').html('');
					showFront(event);
					show();
				}else{
					$('#errorpass').html('DNI o Contraseña incorrectos');
				}
			},
			error:	function(msg){
					$('#errorpass').html('Ocurrió un error al comprobar su dni/contraseña');
			}
		});

}

function limpiar_bloques(){
	$('#anunciosumhtext').html('');
	$('#anunciostitutext').html('');
	$('#content').html('');
	$('#contentasig').html('');
	$('#box').hide();
}

function abrir_miweb(){
	widget.openURL("http://www.davidrojas.net/", null);
}

